' Demo PartEngine

' Tutorial  propos de 
' PartEngine
' par ftbass

'#########################################
' See 2nd part for cleaner code
'#########################################




Strict


Include "partengine062.bmx"


' Paramtres d'affichage
Global LARGEUR = 1024
Global HAUTEUR = 768
Global PROFONDEUR = 32

' Variables pour le calcul du frame rate
Global FPS_Timer, FPS_Frame, FPS_FPS

' Liste chaine qui va contenir tous les fonds
Global ListeFond:TList = New TList
' Liste chaine qui va contenir tous les joueurs
Global ListeJoueur:TList = New TList
' Liste chaine qui va contenir les bonus
Global ListeBonus:TList = New TList

' Type Fond
Type TFond
	Field image:TImage		' Image du fond
	Field x%, y%		' Coordonnes
	Field dx%		' Vitesse de dfilement
	
	' Methode qui met  jour les coord du fond
	Method Update()
		x = x + dx
		If x < -1023 Then
			x = 0
		End If
	End Method
	
	' Methode qui dessine le fond
	Method Draw()
		DrawImage image, x, y
		DrawImage image, 1024 + x, y
	End Method
	
End Type

' On dfinit un type TVaisseau qui sera le parent de tous les autres Vaisseau
Type TVaisseau

	Field Image : TImage = LoadAnimImage("incbin::Medias/Play_All_Glued2.png", 128, 128, 0, 22)
	Field X% = MouseX()			' Position X
	Field Y% = MouseY()			' Position Y
	Field NumImage%				' Numro de l'image  afficher
	Field Vitesse% = 1			' Coefficient pour la vitesse du vaisseau
	Field Bouclier%				' Niveau de vie du vaisseau
	Field Timer% = MilliSecs()		' Timer pour les animations
	Field Tempo% = 30				' Tempo entre chaque animation
	Field DirV$ = "null"			' Direction verticale
	Field Etat$ = "vivant"			' Etat du vaiseau (vivant, mort, invincible)

	
	' Mise  jour des vaisseaux
	Method Update() Abstract

	' Dessin des vaisseaux
	Method Draw()
		DrawImage Image, X, Y, NumImage
	End Method
	
End Type


' Type Bonus
Type TBonus Extends TVaisseau

	Field TypeBonus%			' Bonus de tir ou de vitesse
	
	
	Method Update()
		
		X = X - 3 * Vitesse
		Y = Y + Cos(MilliSecs()) * 100
		
	End Method
	
	
End Type

' Type TJoueur hrit du type TVaisseau
Type TJoueur Extends TVaisseau

	Method Update()
		If KeyDown(KEY_LEFT) And X >= -10 Then
			X = X - 3 * Vitesse
		EndIf
		If KeyDown(KEY_RIGHT) And X <= (LARGEUR - 112) Then
			X = X + 3 * Vitesse
		EndIf
		If KeyHit(KEY_UP) And Not(KeyDown(KEY_DOWN))
			DirV = "haut"
			NumImage = 11
			Timer = MilliSecs()
		End If
		If KeyDown(KEY_UP)
			If Y >= -40 Then
				Y = Y - 3 * Vitesse
			End If
			If (Timer + Tempo < MilliSecs()) And (NumImage < 21) Then
				NumImage = NumImage + 1
				Timer = MilliSecs()
			End If
		EndIf
		If KeyHit(KEY_DOWN) And Not(KeyDown(KEY_UP))
			DirV = "bas"
			NumImage = 0
			Timer = MilliSecs()
		End If
		If KeyDown(KEY_DOWN)
			If Y <= 680 Then
				Y = Y + 3 * Vitesse
			End If
			If (Timer + Tempo < MilliSecs()) And (NumImage < 10) Then
				NumImage = NumImage + 1
				Timer = MilliSecs()
			End If
		EndIf
		If Not(KeyDown(KEY_DOWN) Or KeyDown(KEY_UP))
			Select DirV
				Case "haut"
					If (Timer + Tempo < MilliSecs()) And (NumImage > 11) Then
						NumImage = NumImage - 1
						Timer = MilliSecs()
					ElseIf NumImage = 11 Then
						DirV = "null"
					End If
				Case "bas"
					If (Timer + Tempo < MilliSecs()) And (NumImage > 0) Then
						NumImage = NumImage - 1
						Timer = MilliSecs()
					ElseIf NumImage = 0 Then
						DirV = "null"
					End If
			End Select
		End If
	End Method
	
End Type



Graphics LARGEUR, HAUTEUR, PROFONDEUR
HideMouse

''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' Mdias du jeu
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''

Incbin "Medias/Fond_Plan_1.png"
Incbin "Medias/Fond_Plan_2.png"
Incbin "Medias/Play_All_Glued2.png"
Incbin "Medias/fire.tga"
Incbin "Medias/bluspark.png"
Incbin "Medias/smoke1.png"


' Fonds
Global gfxFond1:TImage = LoadImage("incbin::Medias/Fond_Plan_1.png")
Global gfxFond2:TImage = LoadImage("incbin::Medias/Fond_Plan_2.png")
'Particule
Global gfxPart1:TImage = LoadImage("incbin::Medias/fire.tga")
Global gfxPart2:TImage = LoadImage("incbin::Medias/bluspark.png")
Global gfxPart5:TImage = LoadImage("incbin::Medias/smoke1.png")

Local Joueur1:TJoueur = New(TJoueur)
ListeJoueur.AddLast Joueur1

''''''''''''''''''''''''''''
' Particles settings
''''''''''''''''''''''''''''
Global e:TEmetteur = P2D_CreateEmetteur(gfxPart1, -1, LARGEUR/2, HAUTEUR/2, 0, 4, 0, 2, "light")
P2D_ReglerEchelle(e, .5, .3, .2, .1, 0, -.01)
P2D_ReglerAlpha(e, .8, .2, -0.005, 0)
P2D_ReglerVelocite(e, -5, 0, 0, 0)
P2D_ReglerVie(e, 2000, 0)



Rem 
			On cre 2 objets de Type TFond
			Avec des vitesses diffrentes
			Ce qui va permettre de donner 
			une impression de profondeur
End Rem
CreateFond(gfxFond2, 0, 0, -2)
CreateFond(gfxFond1, 0, 0, -3)


While Not KeyHit(KEY_ESCAPE)
	
	Update1rstPart()
	Render1rstPart()
	
	DrawText "Memoire allouee par l'application : " + GCMemAlloced(), 0, 20
	DrawText "FPS = " + FPS(), 0, 40
	
	DrawText "Appuyer sur ESC pour la suite", 0, 748
	
	Flip
	Cls

Wend

P2D_SupprEmt(e, 1)




'############################################
'
' 2nd part start
'
'############################################

'''''''''''''''''''''''''''''''''''''''''''''
' See this part for cleaner and simpler code
'''''''''''''''''''''''''''''''''''''''''''''


' Particles creation and settings
Local e1:TEmetteur = P2D_CreateEmetteur(gfxPart5, -1, LARGEUR/2, HAUTEUR/2, 100, 100, 0, 1, "alpha")
P2D_ReglerEchelle(e1, .5, .02, .5, .02, .02, .02)
P2D_ReglerAlpha(e1, .8, 0, -.01, 0)
P2D_ReglerVelocite(e1, 0, -2, 0, 0)
P2D_ReglerVie(e1, 2000, 200)

Local e2:TEmetteur = P2D_CreateEmetteur(gfxPart2, -1, LARGEUR/3, HAUTEUR/3, 100, 100, 0, 1, "light")
e2.ReglerEchelle(.5, .5, .2, .2, .05, .05)
e2.ReglerAlpha(.8, 0, -.01, 0)
e2.ReglerVelocite(0, -1, 0, 0)
e2.ReglerVie(500, 500)



While Not KeyHit(KEY_ESCAPE)
	
	DrawText "Memoire allouee : " + GCMemAlloced(), 0, 20
	DrawText "FPS = " + FPS(), 0, 40
	
	DrawText "Nombre d'emetteurs : " + CountList(P2D_ListeEmet), 0, 80
	
	If e2.etat = "actif" Then
		DrawText "Appuyer sur ESPACE pour supprimer un emetteur", 0, 748 
		If KeyHit(KEY_SPACE)
			P2D_SupprEmt(e2, 0)
		End If
	Else
		DrawText "Appuyer sur ESPACE pour creer un emetteur", 0, 748
		If KeyHit(KEY_SPACE)
			e2 = P2D_CreateEmetteur(gfxPart2, -1, LARGEUR/3, HAUTEUR/3, 100, 100, 0, 1, "light")
			e2.ReglerEchelle(.5, .5, .2, .2, .05, .05)
			e2.ReglerAlpha(.8, 0, -.01, 0)
			e2.ReglerVelocite(0, -1, 0, 0)
			e2.ReglerVie(500, 500)
		End If
	End If
	
	' 2nd emitter moving with the mouse
	P2D_ReglerPosition(e2, MouseX(), MouseY())
	
	' Emitters / Particles updating
	P2D_Update()

	' Particles drawing
	P2D_Afficher()

	Flip
	Cls
	
Wend

' removing emitters
P2D_SupprEmt(e1, 1)
P2D_SupprEmt(e2, 1)

'############################################
'
' 2nd part end
'
'############################################








' Mise  jour de tous les lments du jeu
Function Update1rstPart()

	Local Fond : TFond
	Local Joueur : TJoueur
'	Local Emetteur : TEmetteur

	' Mise  jour des fond
	For Fond=EachIn ListeFond
    		Fond.Update()
  	Next

	' Mise  jour des joueurs
	For Joueur=EachIn ListeJoueur
    		Joueur.Update()

		P2D_ReglerPosition(e, Joueur.x + 22, Joueur.y + 68) 
  	Next

	' Update des particules
	P2D_Update()
	
End Function




' Affichage de tous les lments du jeu
Function Render1rstPart()

	Local Fond : TFond
	Local Joueur : TJoueur

	' Affichage des fonds
	For Fond=EachIn ListeFond
    		Fond.Draw()
  	Next

	' Affichage des joueurs
	For Joueur=EachIn ListeJoueur
    		Joueur.Draw()
  	Next

	' Affichage des particules
	P2D_Afficher()

End Function


' Creation d'un objet Fond
Function CreateFond:TFond(image:TImage, x%, y%, dx%)

	Local f:TFond = New TFond
			
	f.image = image
	f.x = x
	f.y = y
	f.dx = dx
	' On l'ajoute  la liste des fonds
	ListAddLast ListeFond, f
	Return f

End Function


' Fonction qui calcule les FPS
Function FPS:Int()

	If (MilliSecs() < (FPS_Timer + 1000)) Then 
		FPS_Frame = FPS_Frame + 1 
	Else 
		FPS_FPS = FPS_Frame 
		FPS_Frame = 0 
		FPS_Timer = MilliSecs() 
	End If 
	Return FPS_FPS
	
End Function

 